//---------------------------------------------------------------------------
#include <vector>
#include <map>
#include <String>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <io.h>
#include <stdio.h>
#include "node.hpp"
#include "database.h"
#include <windows.h>
#include <dir.h>
#include  <time.h>
#include  <process.h>
#pragma hdrstop
using namespace std;

/////////////////////////////////////////////////////////////////////////////
#pragma argsused
#ifndef IGNNRE_PARAMETER
#define IGNORE_PARAMETER(n) ((void)n)
#endif
static char	debug_log_filename[FILENAME_MAX];	// fobOOo̓t@C(tpX)
static char	debug_log_initialize_flag  = (1);	// fobOOtO
/********************************************************************************/
// sentencekeyrepŒuB
/********************************************************************************/
void replace_character(char *sentence, const char *key, const char *rep)
{
    char* p;
    char* q;
    char* str;
    int klen=strlen(key);
    int rlen=strlen(rep);
    int slen=strlen(sentence);
    int num;
    if ( klen == 0 || slen == 0){
        return;
    }
    p = strstr(sentence, key);
    if( klen == rlen ){
        while (p != NULL){
            memcpy( (char*)p,(char*)rep,rlen);
            p = strstr(p+rlen, key);
        }
        //Olߒû܂܃Rs[΂
    }else if( klen > rlen ){
        num = klen-rlen;
        while (p != NULL){
            q = p;
            while( 1 ){
                *(char*)q = *(char*)(q+num);
                if( *(char*)(q+num) == 0 ){
                    break;
                }
                q++;
            }
            memcpy( p,rep,rlen);
            p = strstr(p+rlen, key);
            //slen -= num;
        }
        //ûŌl߂
    }else{
        while (p != NULL){
            num = rlen-klen;
            //prlen-klen̂΂
            for( str = sentence+slen+num ; str-num >= p ; str-- ){
                *str = *(str-num);
            }
            memcpy( p,rep,rlen);
            p = strstr(p+rlen, key);
            slen += num;
        }
    }
    //myfree(buf);
    return;
}
/********************************************************************************/
// "YYYY/MM/DD HH:MM:SS" `݂̌̓̕𐶐B
/********************************************************************************/
void make_datetime_string(char *sentence)
{
    time_t                       now;
    struct tm                   *tm_p;
    // ݎGet.
    time(&now);
    tm_p = localtime(&now);
    sprintf(sentence,    "%04d/%02d/%02d %02d:%02d:%02d",
    tm_p->tm_year+1900  ,       // N
    tm_p->tm_mon+1      ,               // 
    tm_p->tm_mday       ,               // 
    tm_p->tm_hour       ,               // 
    tm_p->tm_min        ,               // 
    tm_p->tm_sec                );      // b
    return;
}
//*******************************************************************
// fobOo͏(t@CZbg)֐
// ̊֐ŏɌĂԂ܂ł́AfobOO͈؏o͂ȂB
//*******************************************************************
void debug_log_initialize(const char *set_debug_log_filename)
{
    // `FbN
    if (set_debug_log_filename == NULL){
        return;
    }
    if ( strlen(set_debug_log_filename) == 0 ){
        return;
    }
    // fobOOt@CZbgB
    strncpy(debug_log_filename, set_debug_log_filename,	sizeof(debug_log_filename) );
    // fobOO tO0ɁB
    debug_log_initialize_flag = 0;
    return;
}
//*************************************************
// fobOo͗p֐B
// printf() ƓtH[}bgɂĎgpB
//*************************************************
void debug_log_output(const char *fmt, ...)
{
#ifdef _DEBUG
    int        fd;
    char       buf[1024*5+1]={0};
    char       work_buf[1024*4+1]={0};
    char       date_and_time[32];
    char       replace_date_and_time[256]={0};
#ifdef linux
    struct timeval tv;
#endif
    va_list     arg;
    int         len;
    // =========================================
    // fobOO tO`FbN
    // =========================================
    if (debug_log_initialize_flag != 0 ){
        return;
    }
    // =========================================
    // Debugo͕񐶐B
    // sɁAdate_and_time }Ă
    // =========================================
    //memset(buf, '\0', sizeof(buf));
    //memset(work_buf, '\0', sizeof(work_buf));
    // ŗ^ꂽWJB
    va_start(arg, fmt);
    vsnprintf(work_buf, sizeof(work_buf), fmt, arg);
    va_end(arg);
    // work_buf̈ԍŌ'\n'Ă폜B
    len = strlen(work_buf);
    if (len > 0 && work_buf[len-1] == '\n'){
        work_buf[len-1] = '\0';
    }
    // }p񐶐( "\ndate_and_time" ɂȂ)
    make_datetime_string(date_and_time);
#ifdef linux
    gettimeofday(&tv,NULL);
    snprintf(replace_date_and_time, sizeof(replace_date_and_time), "\n%s.%06d[%d] ", date_and_time, (int)tv.tv_usec, getpid() );
#else
    snprintf(replace_date_and_time, sizeof(replace_date_and_time), "\n%s.%03d[%d] ", date_and_time, (::GetTickCount() % 1000),GetCurrentThreadId() );
#endif
    
    // o͕񐶐JnB
    //QueryPerformanceCounter((LARGE_INTEGER*)&num);
#ifdef linux
    snprintf((char*)buf, sizeof(buf), "%s.%06d[%d] %s", date_and_time, (int)tv.tv_usec, getpid(), work_buf);
#else
    snprintf(buf, sizeof(buf), "%s.%03d[%d] %s", date_and_time, (::GetTickCount() % 1000),getpid(), work_buf);
#endif
    //last = num;
    replace_character(buf, "\n", replace_date_and_time); // \n̑Odate_and_time}
    // ԍŌ'\n'B
    strncat(buf, "\n", sizeof(buf)-strlen(buf) );
    // =====================
    // Ot@Co
    // =====================
    fd = open(debug_log_filename, O_CREAT | O_APPEND | O_WRONLY | O_BINARY , S_IREAD | S_IWRITE );
    if ( fd < 0 ){
        return;
    }
    // o
    write(fd, buf, strlen(buf));    // bZ[Ŵo
    // t@CN[Y
    close( fd );
    return;
//DEBUG`ĂȂꍇOo͂Ȃ
#else
    IGNORE_PARAMETER(fmt);
#endif
}
/////////////////////////////////////////////////////////////////////////////
void err(const char* msg)
{
#if 1
    perror( msg );
#else
    debug_log_output(msg);
#endif
}
/////////////////////////////////////////////////////////////////////////////
int FileExists(const char* str)
{
    #ifdef linux
    struct stat send_filestat;
    int  result = stat(str, &send_filestat);
    if ( ( result == 0 ) && ( S_ISREG(send_filestat.st_mode) == 1 ) ){
        return 1;
    }
    #else
    struct ffblk send_filestat;
    int result = findfirst(str,&send_filestat, 0);
    if( result == 0 && ( send_filestat.ff_attrib & FA_DIREC ) == 0){
        return 1;
    }
    #endif
    return 0;
}
/////////////////////////////////////////////////////////////////////////////
bool RenameFile(const string src, const string dst)
{
    if( rename(src.c_str(), dst.c_str()) == 0 ){
        return true;
    }else{
        return false;
    }
}
/////////////////////////////////////////////////////////////////////////////
int DeleteFile(const string str)
{
#ifdef linux
    return (unlink(str.c_str())==0);
#else
    if( FileExists(str.c_str()) ){
        return (unlink(str.c_str())==0);
    }
    return false;
#endif
}
////////////////////////////////////////////////////////////////////////////
int getToken(unsigned char* sql, unsigned char* token)
{
    unsigned char* p=sql;
    while( *p && *p <= ' ') p++;
    if( *p ){
        //cmd?
        for( size_t i = 0 ; i < flen ; i++ ){
            if( strnicmp(p,ccmd[i],clen[i]) == 0 && (clen[i] == 1 || (! isalpha(p[clen[i]])))  ){
                strcpy( token, ccmd[i]);
                p += clen[i];
                while( *p )  *sql++ = *p++;
                *sql = 0;
                return ctyp[i];
            }
        }
        //token
        unsigned char* q = token;
        //擪Ȃ當I܂
        *q = 0;
        if( *p == '`' ){
            *p++;
            while( *p && *p != '`' ){
               if( *p == '\\' ){
                   *p++;
                   *q++ = *p++;
               }else{
                   *q++ = *p++;
               }
            }
            if( *p++ == 0 ) {
                err("Invalid quote");
                return -1;
            }
        }else{
            //As؂o
            if( *p && (*p == '=' || *p == '>' || *p == '<' ) ){
                while( *p && *p == '=' || *p == '>' || *p == '<' )  *q++ = *p++;
            //tB[h؂o
            }else{
                while( *p && strchr(" ,=><;()",*p) == NULL)         *q++ = *p++;
            }
        }
        *q = 0;
        //" "΂
        while( *p == ' ' )  p++;
        //cRs[
        while( *p )         *sql++ = *p++;
        *sql = 0;
        return TXARG;
        
    }
    return TXNONE;
}
////////////////////////////////////////////////////////////////////////////
//CMD Check
int chkToken(unsigned char* sql, unsigned char* token, CTYP cmd)
{
    return ( cmd != getToken(sql,token) );
}
/////////////////////////////////////////////////////////////////////////////
//JNX
//JRXgN^
Column::Column(void)
{
}
/////////////////////////////////////////////////////////////////////////////
//JRXgN^
Column::Column(const string tbl, const string nam, const dataType typ)
{
    size_t cutAt = nam.find_first_of(".");
    if( cutAt == nam.npos ){
        table = tbl;
        name  = nam;
    }else{
        table = nam.substr(0, cutAt);
        name  = nam.substr(cutAt + 1);
    }
    type     = typ;
}
/////////////////////////////////////////////////////////////////////////////
//JRXgN^
Column::Column(const Column* clm)
{
    table    = clm->table;
    name     = clm->name;
    type     = clm->type;
}
/////////////////////////////////////////////////////////////////////////////
//GCAXݒ
void Column::AddAlias(const string myalias)
{
    alias    = myalias;
}
/////////////////////////////////////////////////////////////////////////////
//e[uLƃGCAXlvI select = TableName.ColumnName
int Column::Compare( string select, map<string,string>& clmalias, map<string,string>& tblalias)
{
    //S̔r
    if( clmalias.count(select) ){
        clmalias[select];
    }
    //؂o
    size_t cutAt = select.find_first_of(".");
    if( cutAt == select.npos ){
        return ( select == name || select == alias);
    }else{
        string ot = select.substr(0, cutAt);
        string nm = select.substr(cutAt + 1);
        if( tblalias.count(ot) ) ot = tblalias[ot];
        return ( table == ot && nm == name );
    }
}
/////////////////////////////////////////////////////////////////////////////
//Jۑ
int Column::SaveToFile(int fd)
{
    int            ret;
    unsigned char  len;
    //擾e[uۑ
    len = table.length();
    if( write( fd,&len,sizeof(unsigned char) ) != sizeof(unsigned char)) return -1;
    if( write( fd,table.c_str(),len )          != (int)len             ) return -1;
    //Jۑ
    len = name.length();
    if( write( fd,&len,sizeof(unsigned char) ) != sizeof(unsigned char)) return -1;
    if( write( fd,name.c_str(),len )           != (int)len             ) return -1;
    //^Cvۑ
    if( write( fd,&type,sizeof(dataType))      != sizeof(dataType)     ) return -1;
    return 0;
}
/////////////////////////////////////////////////////////////////////////////
//JA
int Column::LoadFromFile(int fd)
{
    int ret;
    unsigned char len;
    char work[256];

    //擾e[u擾
    if( read( fd,&len,sizeof(unsigned char) ) != sizeof(unsigned char)) return -1;
    if( read( fd,work,len )                   != (int)len             ) return -1;
    work[len] = 0;
    table = work;

    //J擾
    if( read( fd,&len,sizeof(unsigned char) ) != sizeof(unsigned char)) return -1;
    if( read( fd,work,len )                   != (int)len             ) return -1;
    work[len] = 0;
    name = work;

    //^Cv擾
    if( read( fd,&type,sizeof(dataType))      != sizeof(dataType)     ) return -1;
    return 0;
}
/////////////////////////////////////////////////////////////////////////////
//RXgN^
Table::Table(void)
{
    ref = 0;
    //NeBJZNV
#ifdef linux
    pthread_mutexattr_t attr;
    pthread_mutexattr_init(&attr);
    pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE_NP);
    pthread_mutex_init(&mutex, &attr);
#else
    InitializeCriticalSection(&cs);
#endif
}
/////////////////////////////////////////////////////////////////////////////
//CSVe[u쐬
Table::Table(char* myname, char* mycolumn){
    vector<string> clmns;
    //NeBJZNV
    ref = 0;
#ifdef linux
    pthread_mutexattr_t attr;
    pthread_mutexattr_init(&attr);
    pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE_NP);
    pthread_mutex_init(&mutex, &attr);
#else
    InitializeCriticalSection(&cs);
#endif
    writeStart();
    name  = myname;
    //clmnsCSVCT[g
    char work[4096];
    strcpy(work, mycolumn);
    char* tp = strtok(work,",");
    clmns.push_back(tp);
    while( tp != NULL ){
        tp = strtok(NULL,",");
        if( tp != NULL ){
            clmns.push_back(tp);
        }
    }
    dataType typs;
    for( size_t i = 0 ; i < clmns.size() ; i++ ){
        unsigned int ptr = clmns[i].find(":");
        typs = STRING;
        if( ptr != string::npos ){
            string tp_ = clmns[i].substr(ptr+1);
            clmns[i] = clmns[i].substr(0,ptr);
            if( tp_ == "string" ){
                typs = STRING;
            }else if ( tp_ == "number" ){
                typs = NUMBER;
            }
        }
        Column* clm = new Column(name,clmns[i],typs);
        column.push_back( clm );
        node.push_back( new Node(typs));
        //delete clm;
    }
    writeEnd();
}
/////////////////////////////////////////////////////////////////////////////
//Stringz񂩂e[u쐬
Table::Table(const string myname, const vector<string>& mycolumn){
    //NeBJZNV
    ref = 0;
#ifdef linux
    pthread_mutexattr_t attr;
    pthread_mutexattr_init(&attr);
    pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE_NP);
    pthread_mutex_init(&mutex, &attr);
#else
    InitializeCriticalSection(&cs);
#endif
    writeStart();
    name  = myname;
    for( size_t i = 0 ; i < mycolumn.size() ; i++ ){
        Column* clm = new Column(name,mycolumn[i]);
        column.push_back( clm );
        node.push_back( new Node(clm->type));
    }
    writeEnd();
}
/////////////////////////////////////////////////////////////////////////////
//J񂩂e[u쐬
Table::Table(const string myname, const vector<Column*> mycolumn){
    //NeBJZNV
    ref = 0;
#ifdef linux
    pthread_mutexattr_t attr;
    pthread_mutexattr_init(&attr);
    pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE_NP);
    pthread_mutex_init(&mutex, &attr);
#else
    InitializeCriticalSection(&cs);
#endif
    writeStart();
    name  = myname;
    for( size_t i = 0 ; i < mycolumn.size() ; i++ ){
        Column* clm = new Column(mycolumn[i]);
        column.push_back( clm );
        node.push_back( new Node(clm->type));
    }
    writeEnd();
}
/////////////////////////////////////////////////////////////////////////////
//fXgN^
Table::~Table(){
    for( size_t i = 0 ; i < column.size() ; i++ ){
        delete column[i];
    }
    for( size_t i = 0 ; i < node.size() ; i++ ){
        delete node[i];
    }
    //NeBJZNVj
    DeleteCriticalSection(&cs);
}
/////////////////////////////////////////////////////////////////////////////
void Table::readStart(void)
{
    //݃ZbV͂ő҂
#ifdef linux
    pthread_mutex_lock(&mutex);
#else
    EnterCriticalSection(&cs);
#endif
    ref++;
#ifdef linux
    pthread_mutex_unlock(&mutex);
#else
    LeaveCriticalSection(&cs);
#endif
}
/////////////////////////////////////////////////////////////////////////////
void Table::readEnd(void)
{
    ref--;
}
/////////////////////////////////////////////////////////////////////////////
void Table::writeStart(void)
{
    //ǂݍݏI҂B
    //ǂݍ݂[悤łΔÂ炢낤A܂
    while( ref ){Sleep(10);}
#ifdef linux
    pthread_mutex_lock(&mutex);
#else
    EnterCriticalSection(&cs);
#endif
}
/////////////////////////////////////////////////////////////////////////////
void Table::writeEnd(void)
{
#ifdef linux
    pthread_mutex_unlock(&mutex);
#else
    LeaveCriticalSection(&cs);
#endif
}
/////////////////////////////////////////////////////////////////////////////
//e[uRs[
void  Table::copy(Table* tbl)
{
    tbl->writeStart();
    writeStart();
    name = tbl->name;             //e[u
    alias = tbl->alias;           //e[uGCAX
    column.clear();
    for( size_t i = 0 ; i < tbl->column.size() ; i++ ){
       column.push_back(new Column(tbl->column[i]));
    }
    node.clear();
    for( size_t i = 0 ; i < tbl->node.size() ; i++ ){
       node.push_back(new Node(tbl->node[i]));
    }
    writeEnd();
    tbl->writeEnd();
    //vector<int>     index;        //orderbỹtB^
}
/////////////////////////////////////////////////////////////////////////////
//e[uf[^擾
vector<Node*> Table::getTable(void){
    return node;
}
//e[uCT[g(CSV)
//JĂȂ`FbNĂȂ̂ŎcNULLǉ
int Table::Insert(const char* data){
    vector<char*>tmp;
    char work[4096];
    writeStart();
    //sJn
    strcpy(work,data);
    char* tp = strtok(work,",");
    tmp.push_back(tp);
    while( tp != NULL ){
        tp = strtok(NULL,",");
        if( tp != NULL ){
            tmp.push_back(tp);
        }
    }
    if( tmp.size() != column.size() ){
        err( "Invalid number of column");
        writeEnd();
        return -1;
    }
    Insert(tmp);
    writeEnd();
    return 0;
}
//e[uCT[g
int Table::Insert(const vector<string>& clm,const vector<string>& data){
    if( column.size() != clm.size() || clm.size() != data.size() ) {
        err( "Illigal number of data");
        return -1;
    }
    writeStart();
    //TODO:Jƍvf[^𓊓邱
    for( size_t i = 0 ; i < data.size(); i++ ){
        node[i]->put(data[i].c_str());
    }
    writeEnd();
    return 0;
}
//e[uCT[g
int Table::Insert(const vector<char*>& data){
    if( column.size() != data.size()) {
        err( "Illigal number of data");
        return -1;
    }
    writeStart();
    for( size_t i = 0 ; i < data.size(); i++ ){
        node[i]->put(data[i]);
    }
    writeEnd();
    return 0;
}
Table* Table::Select(const vector<string>& Colnums,map<string,string>& clmalias, map<string,string>& tblalias)
{
    readStart();
    vector<int>    select;
    //TODO:JȂꍇ
    for( size_t i = 0 ; i < Colnums.size() ; i++ ){
        for( size_t j = 0 ; j < column.size() ; j++ ){
            if( column[j]->Compare(Colnums[i],clmalias,tblalias) ){
                select.push_back(j);
                break;
            }
        }
    }
    if( select.size() != Colnums.size() ){
       err( "Column name not found" );
       readEnd();
       return NULL;
    }
    //selectŎꂽ̂̂selectňڍs
    Table* newTable = new Table(name, Colnums);
    for( size_t i = 0 ; i < select.size() ; i++ ){
        *newTable->node[i] = *node[select[i]];
    }
    //indexRs[
    newTable->index = index;
    readEnd();
    return newTable;
}
//בւ
Table* Table::OrderBy(string targetColumn,map<string,string>& clmalias, map<string,string>& tblalias,orderType type){
    readStart();
    for( size_t i = 0 ; i < column.size() ; i++ ){
        if( column[i]->Compare(targetColumn,clmalias,tblalias) ){
            node[i]->sort(index,type);
            readEnd();
            return this;
        }
    }
    readEnd();
    return NULL;
}
//e[uɃJǉ
void Table::AddColumn(vector<Column*> addColumn){
    //column.push_back( Column);
    for( size_t i = 0 ; i < addColumn.size() ; i++ ){
        Column *clm = new Column(addColumn[i]);
        column.push_back(clm);
        node.push_back( new Node(clm->type));
    }
}
//Left join
Table* Table::LeftJoin(Table* joinTable, const vector<string>& cond){
#if 0
    int col1=-1;
    int col2=-1;
    string rarg1;
    string rarg2;
    dataType typ=STRING;
    Table* colTbl1=NULL;
    Table* colTbl2=NULL;
    //Ve[u
    joinTable->writeStart();
    writeStart();
    Table* newTable = new Table(name , column);
    newTable->AddColumn(joinTable->column);
    //J`FbN
    for( size_t i = 0 ; i < newTable->column.size() ; i++ ){
        if( newTable->column[i]->Compare(arg1)){
            if( col1 >= 0 ) err( "Column name arg1 is ambigous" );
            col1 = i;
            colTbl1 = this;
            typ = newTable->column[i]->type;
        }
        if( newTable->column[i]->Compare(arg2)){
            if( col2 >= 0 ) err( "Column name arg2 is ambigous" );
            col2 = i;
            colTbl2 = this;
            typ = newTable->column[i]->type;
        }
    }
    //J`FbN
    for( size_t i = 0 ; i < joinTable->column.size() ; i++ ){
        if( joinTable->column[i]->Compare(arg1)){
            if( col1 >= 0 ) err( "Column name arg1 is ambigous" );
            col1 = i;
            colTbl1 = joinTable;
            typ = newTable->column[i]->type;
        }
        if( joinTable->column[i]->Compare(arg2)){
            if( col2 >= 0 ) err( "Column name arg2 is ambigous" );
            col2 = i;
            colTbl1 = joinTable;
            typ = newTable->column[i]->type;
        }
    }
    //e[uSsɂ
    for( size_t i = 0 ; i < node[0]->size() ; i++ ){
        int cnt = 0;
        //e[uPsǉ
        for(size_t k = 0 ; k < node.size() ; k++ ){
            newTable->node[cnt++]->put(node[k]->getNode(i));
        }
        //Qƃe[uSsɂ
        int flag = 0;
        for( size_t j = 0 ; j < joinTable->node[0]->size() ; j++ ){
            rarg1 = arg1;
            rarg2 = arg2;
            if( col1>=0 ) rarg1 = colTbl1->node[col1]->getNode(colTbl1==this?i:j);
            if( col2>=0 ) rarg2 = colTbl2->node[col2]->getNode(colTbl2==this?i:j);
            //vȂ
            if( newTable->compare(rarg1,op,rarg2,typ) ){
                //e[uPsǉ
                for(size_t k = 0 ; k < joinTable->node.size() ; k++ ){
                    newTable->node[cnt++]->put(joinTable->node[k]->getNode(j));
                }
                flag = 1;
                break;
            }
        }
        if( flag == 0 ){
            //e[uPsǉ
            for(size_t k = 0 ; k < joinTable->node.size() ; k++ ){
                newTable->node[cnt++]->put(NULL);//NULL͕\łȂH
            }
        }

    }
    writeEnd();
    joinTable->writeEnd();
    return newTable;
#endif
    }
/////////////////////////////////////////////////////////////////////////////
//intersection
Table* Table::Intersection(Table* Table2){
    writeStart();
    Table2->writeStart();
    //Ve[ũJɎJRs[
    Table* newTable = new Table(name, column);
    //Ve[ũJɃ^[QbgJRs[
    newTable->AddColumn(Table2->column);
    //e[uSsɂ
    for( size_t i = 0 ; i < node[0]->size() ; i++ ){
        //Qƃe[uSsɂ
        for( size_t j = 0 ; j < Table2->node[0]->size() ; j++ ){
            int cnt = 0;
            char work[1024];
            //e[uPsǉ
            for(size_t k = 0 ; k < node.size() ; k++ ){
                newTable->node[cnt++]->put(node[k]->getNode(i,work));
            }
            //e[uPsǉ
            for(size_t k = 0 ; k < Table2->node.size() ; k++ ){
                newTable->node[cnt++]->put(Table2->node[k]->getNode(j,work));
            }
        }
    }
    writeEnd();
    Table2->writeEnd();
    return newTable;
}
/////////////////////////////////////////////////////////////////////////////
//z񐶐
int Table::condition_mat(const vector<string>& cond, map<string,string>& clmalias, map<string,string>& tblalias,vector<char>& mat)
{
    int    col1;
    int    col2;
    string arg1;
    string arg2;
    string op;
    string rarg1;
    string rarg2;
    dataType typ=STRING;
    //Ve[uЂȌ`
    if( cond.size() % 4 != 0 ){
        err( "SELECT:Illigal condition setting");
        return -1;
    }
    //s̕1ݒ
    mat.clear();
    for( size_t i = 0 ; i < node[0]->size() ; i++ ){
       mat.push_back(1);
    }
    //eɂAND,a,>,4
    for( size_t ptr = 0 ; ptr < cond.size() ; ptr+= 4 ){
        int lop;
        col1 = -1;
        col2 = -1;
        if       ( stricmp( cond[ptr].c_str(),"OR") == 0 ){
            lop = 1;
        }else if ( stricmp( cond[ptr].c_str(),"AND") == 0 ){
            lop = 2;
        }else{
            err( "SELECT:Logical Operation Error");
            return -1;
        }
        //̃Rs[
        arg1 = cond[ptr+1];
        op   = cond[ptr+2];
        arg2 = cond[ptr+3];
        //J`FbN
        for( size_t i = 0 ; i < column.size() ; i++ ){
            if( column[i]->Compare(arg1,clmalias,tblalias)){
                if( col1 >= 0 ) {err( "Column name arg1 is ambigous" );return -1;}
                col1 = i;
                typ = column[i]->type;
            }
            if( column[i]->Compare(arg2,clmalias,tblalias)){
                if( col2 >= 0 ) {err( "Column name arg2 is ambigous" );return -1;}
                col2 = i;
                typ = column[i]->type;
            }
        }
        rarg1 = arg1;
        rarg2 = arg2;
        char work[1024];
        for( size_t i = 0 ; i < node[0]->size() ; i++ ){
            if( col1>=0 ) rarg1 = node[col1]->getNode(i,work);
            if( col2>=0 ) rarg2 = node[col2]->getNode(i,work);
            //vȂ
            if( lop == 1 ){//OR
                if( mat[i] == 0 ){
                    if( compare(rarg1,op,rarg2,typ) ){
                        mat[i] = 1;
                    }
                }
            }else{        //AND
                if( mat[i] == 1 ){
                    if( ! compare(rarg1,op,rarg2,typ) ){
                        mat[i] = 0;
                    }
                }
            }
        }
    }
    return 0;
}
/////////////////////////////////////////////////////////////////////////////
//e[ui
Table* Table::Where(const vector<string>& cond,map<string,string>& clmalias, map<string,string>& tblalias)
{
    vector<char> mat;
    //z񐶐
    if( condition_mat(cond,clmalias,tblalias,mat) ) return NULL;
    Table* newTable = new Table(name, column);
    //]LxN^[ɏ]ē]L
    for( size_t i = 0 ; i < newTable->column.size() ; i++ ){
        newTable->node.push_back(new Node(newTable->column[i]->type));
        for( size_t j = 0 ; j < node[i]->size() ; j++ ){
            if( mat[j] ){
                char work[1024];
                newTable->node[i]->put(node[i]->getNode(j,work));
            }
        }
    }
    return newTable;
}
/////////////////////////////////////////////////////////////////////////////
//e[uXV
int Table::Update(const vector<string>& colnams,const vector<string>& values,const vector<string>& cond,map<string,string>& clmalias, map<string,string>& tblalias)
{
    //XVJ̔ԍ
    vector<int> matcol;
    for( size_t i = 0 ; i < column.size() ; i++ ){
        for( size_t j = 0 ; j < colnams.size() ; j++ ){
            if( column[i]->Compare(colnams[j],clmalias,tblalias)) {
                matcol.push_back(i);
                break;
            }
        }
    }
    //vȂXVJꍇ
    if( matcol.size() != colnams.size() ) {err("undefined column name found");return -1;}

    //z񐶐
    vector<char> mat;
    if( condition_mat(cond,clmalias,tblalias,mat) ) return -1;

    //sXV
    for( size_t i = 0 ; i < node[0]->size() ; i++ ){
        if( mat[i]  == 1 ){
            for( size_t j = 0 ; j < matcol.size() ; j++ ){
                //ԍw肵čXV
                node[matcol[j]]->put(values[j].c_str(),i);
            }
        }
    }
    return 0;
}
/////////////////////////////////////////////////////////////////////////////
//e[u폜
int Table::Delete(const vector<string>& cond,map<string,string>& clmalias, map<string,string>& tblalias)
{
    //z񐶐
    vector<char> mat;
    if( condition_mat(cond,clmalias,tblalias,mat) ) return -1;
    //납s
    for( int i = node[0]->size()-1 ; i >= 0  ; i-- ){
        //vȂ
        if( mat[i] ){
            for( size_t j = 0 ; j < node.size() ; j++ ){
                node[j]->Delete(i);//1s폜
            }
        }
    }
    return 0;
}
/////////////////////////////////////////////////////////////////////////////
//r
int Table::compare(const string arg1, const string op , const string arg2, const dataType type ){
    if( type == STRING ){
        if      ( op == "="  ) return arg1 == arg2;
        else if ( op == ">"  ) return arg1 >  arg2;
        else if ( op == ">=" ) return arg1 >= arg2;
        else if ( op == "<"  ) return arg1 <  arg2;
        else if ( op == "<=" ) return arg1 <= arg2;
    }else{
        int iarg1 = atoi(arg1.c_str());
        int iarg2 = atoi(arg2.c_str());
        if      ( op == "="  ) return iarg1 == iarg2;
        else if ( op == ">"  ) return iarg1 >  iarg2;
        else if ( op == ">=" ) return iarg1 >= iarg2;
        else if ( op == "<"  ) return iarg1 <  iarg2;
        else if ( op == "<=" ) return iarg1 <= iarg2;
    }
    err( "this operation not allowed");
    return -2;
}
/////////////////////////////////////////////////////////////////////////////
//VACY
string Table::toString(void){
    string tmp;
    char work[1024];
    size_t i;
    size_t j;
    for( i = 0 ; i < column.size() ; i++ ){
    sprintf( work,"%s%s.%s", (i?"|":""),column[i]->table.c_str(),column[i]->name.c_str());
        tmp += work;
    }
    tmp +="\n";
    //\[gĂȂ\[gԍ
    if( node.size() ){
        for( j = 0 ; j < node[0]->size() ; j++ ){
            for( i = 0 ; i < column.size() ; i++ ){
                char temp[1024];
                sprintf( work,"%s%s", (i?"\t":""),node[i]->get(index,j,temp));
                tmp += work;
            }
            tmp += "\n";
        }
    }
    return tmp;
}
/////////////////////////////////////////////////////////////////////////////
//A
int Table::LoadFromFile(int fd)
{
    size_t len;
    char work[1024];
    writeStart();
    //nameA
    for(;;){
        if( read(fd, &len , sizeof(size_t)) != sizeof(size_t) ) break;
        if( read(fd, work , len)            != (int)len       ) break;
        work[len] = 0;
        name = work;
    
        //ColumnA
        column.clear();
        if( read(fd, &len , sizeof(size_t)) != sizeof(size_t) ) break;
        for( size_t i = 0 ; i < len; i++ ){
            Column* clm = new Column();
            if( clm->LoadFromFile(fd) < 0 )                     break;
            column.push_back(clm);
        }

        //NodeA
        node.clear();
        if( read(fd, &len , sizeof(size_t)) != sizeof(size_t) ) break;
        for( size_t i = 0 ; i < len; i++ ){
            Node* nd = new Node(column[i]->type);
            if( nd->LoadFromFile(fd)  < 0 )                     break;
            node.push_back(nd);
        }
        printf( "%s loaded\n", name.c_str() );
        writeEnd();
        return 0;
    }
    writeEnd();
    return -1;
}
/////////////////////////////////////////////////////////////////////////////
//ۑ
int Table::SaveToFile(int fd)
{
    size_t len;
    //nameۑ
    readStart();
    for(;;){
        len = name.length();
        if( write( fd, &len ,sizeof(size_t)) != sizeof(size_t) ) break;
        if( write( fd, name.c_str(), len)    != (int)len       ) break;
    
        //Columnۑ
        len = column.size();
        if( write( fd, &len, sizeof(size_t)) != sizeof(size_t) ) break;
        for( size_t i = 0 ; i < len ; i++ ){
            if( column[i]->SaveToFile(fd) < 0 )                  break;
        }

        //Nodeۑ
        len = node.size();
        if( write( fd, &len, sizeof(size_t)) != sizeof(size_t) ) break;
        for( size_t i = 0 ; i < len ; i++ ){
            if( node[i]->SaveToFile(fd)   < 0 )                  break;
        }
        printf( "%s saved\n", name.c_str() );
        readEnd();
        return 0;
    }
    readEnd();
    return -1;
}

////////////////////////////////////////////////////////////////////////////
//f[^x[XNX
////////////////////////////////////////////////////////////////////////////
Database::Database(string myname){
    name = myname;
    LoadFromFile(name+".db");
    ref = 0;
}
////////////////////////////////////////////////////////////////////////////
Database::~Database(void){
    if( SaveToFile(name+".db.bak") == 0 ){
        DeleteFile(name+".db"); 
        RenameFile(name+".db.bak",name+".db");
    }
    map<string,Table*>::iterator it;
    for( it = tbllist.begin() ; it != tbllist.end() ; it++ ){
        delete it->second;
    }
}
////////////////////////////////////////////////////////////////////////////
Table* Database::SQL(unsigned char* sql)
{
    map<string,string> clmalias;
    map<string,string> tblalias;
    unsigned char token[256];
    unsigned char token2[256];
    vector<Column*> columns;
    vector<string>  colnams;
    vector<string>  tables;
    vector<string>  values;
    vector<string>  cond;
    vector<string>  order;
    Table* tbl;
    int ret = getToken(sql,token);
    if( ret < 0 ){
        return NULL;
    }
    switch( ret ){
    //SELECT Field1,Field2,.. FROM table1,table2.. WHERE ARG1 OP1 ARG2 (AND/OR ARG3 OP2 ARG4) ORDER BY ARG1,ARG2.. ASC/DESC;
    case  TXSELECT://SELECT
        //J擾
        for(;;){
            if( chkToken(sql,token2,TXARG) )        {err("SELECT NO ARG ERROR");   return NULL;}//ARG
            colnams.push_back( (char*)token2 );

            ret =getToken(sql,token);
            if      ( ret == TXAS ){
                if( chkToken(sql,token,TXARG) )     {err("SELECT NO ARG ERROR");   return NULL;}//ARG
                //GCAXo^
                clmalias[(char*)token] = (char*)token2;
                ret =getToken(sql,token);
            }
            if      ( ret == TXFROM )               break;
            else if ( ret != TXCM )                 {err("SELECT SYNTAX ERROR");   return NULL;}//","
        }
        //e[u擾
        for(;;){
            if( chkToken(sql,token2,TXARG) )        {err("SELECT NO TABLE ERROR"); return NULL;}//table
            tables.push_back( (char*)token2 );
            ret =getToken(sql,token);
            if      ( ret == TXAS ){
                if( chkToken(sql,token,TXARG) )     {err("SELECT NO ARG ERROR");   return NULL;}//ARG
                //e[uGCAXo^
                tblalias[(char*)token] = (char*)token2;
                ret =getToken(sql,token);
            }
            if      ( ret != TXCM )                 break;
        }
        if( ret != TXNONE && ret != TXED ){
            //WHERE擾
            if( ret == TXWHERE ){
                cond.push_back("AND");               //1AND
                for(;;){
                    if( chkToken(sql,token,TXARG) ) {err("SELECT NO ARG IN WHERE"); return NULL;}//arg1
                    cond.push_back((char*)token);
                    if( chkToken(sql,token,TXARG) ) {err("SELECT NO OPE IN WHERE"); return NULL;}//op1
                    if( strstr("= >= <= > < ",(char*)token) == NULL )
                                                    {err("SELECT NO OPE IN WHERE"); return NULL;}//op1
                    cond.push_back((char*)token);
                    if( chkToken(sql,token,TXARG) ) {err("SELECT NO ARG IN WHERE"); return NULL;}//arg2
                    cond.push_back((char*)token);

                    ret = getToken(sql,token);
                    if( ret != TXAND && ret != TXOR){
                        break;
                    }
                    cond.push_back((char*)token);
                }
            }
            //ORDER BY 擾
            if( ret == TXORDER ){
                if( chkToken(sql,token,TXBY) ) {err("SYNTAX ERROR IN ORDER BY");  return NULL;}//arg1
                if( chkToken(sql,token,TXARG) ) {err("ORDER BY NO ARG IN WHERE"); return NULL;}//arg1
                order.push_back((char*)token);
                ret = getToken(sql,token);
                if( ret != TXARG ){
                    order.push_back("ASC");
                }else if ( stricmp( token,"ASC") == 0 ){
                    order.push_back("ASC");
                }else if ( stricmp( token, "DESC") == 0 ){
                    order.push_back("DESC");
                }else{
                    err( "ORDER BY ILLIGAL PARAM" );
                    return NULL;
                }
            }
        }
        //̏
        while( ret != TXED && ret != TXNONE ){
            ret = getToken(sql,token);
        }
        //e[u݃`FbN
        for( size_t i = 0 ; i < tables.size() ; i++ ){
            if( tbllist.count(tables[i]) == 0 ){
                err("Table not found");
                return NULL;
            }
        }
        //e[u擾
        tbl = new Table();
        for( size_t i = 0 ; i < tables.size() ; i++ ){
            if( i == 0 ){
                tbl->copy(tbllist[tables[i]]);
            }else{
                Table* old = tbl;
                tbl = tbl->Intersection(tbllist[tables[i]]);
                delete old;
            }
        }
        //wheres
        if( cond.size() >= 4 ){
            Table* old = tbl;
            tbl = tbl->Where(cond,clmalias,tblalias );
            delete old;
            if( tbl == NULL ){
               return NULL;
            }
        }
        //orderby s
        if( order.size() >= 2 ){
            orderType typ =(order[1] == "ASC")?ASC:DESC;
            tbl->OrderBy(order[0],clmalias,tblalias,typ);
        }
        //selects
        if( colnams.size() != 1 || colnams[0] != "*" ){
            Table* old = tbl;
            tbl = tbl->Select(colnams,clmalias,tblalias);
            delete old;
            if( tbl == NULL ){
                return NULL;
            }
        }
        //󂯎葤delete邱
        return tbl;
        //printf( "%s\n", tbl->toString().c_str() );
        //delete tbl;
    //CREATE TABLE tableName (field number/string, field number/string);
    case  TXCREATE://CREATE
        ret = getToken(sql,token);
        if( ret == TXTBL ){
            if( chkToken(sql,token,TXARG) )      {err("CREATE TABLE NO TABLE ERROR"); return NULL;}//tablename
            tables.push_back( (char*)token );

            if( chkToken(sql,token,TXPS) )       {err("CREATE TABLE SYNTAX ERROR");   return NULL;}//(
            for(;;){
                if( chkToken(sql,token,TXARG) )  {err("CREATE TABLE INVALID ARGS");   return NULL;}//field name
                if( chkToken(sql,token2,TXARG) || ( stricmp(token2,"number") != 0 && stricmp(token2,"string") != 0 ) )
                                                 {err("CREATE TABLE INVALID ARGS");   return NULL;}//number/string
                dataType typ = (stricmp(token2,"number")==0)?NUMBER:STRING;
                Column* clm = new Column(tables[0],(char*)token,typ);
                columns.push_back(clm);
                ret = getToken(sql,token);
                if      ( ret == TXPE )          break;
                else if ( ret != TXCM )          {err("CREATE TABLE SYNTAX ERROR");   return NULL;}//number/string
            }
            //e[u쐬
            //`FbNBɓ̃e[uȂH
            if( tbllist.count(tables[0]) ){
                err( "Table already exists");
                return NULL;
            }
            Table* tbl = new Table(tables[0],columns);//i
            tbllist[tables[0]] = tbl;
            for( size_t i = 0 ; i < columns.size() ; i++ ){
                delete columns[i];
            }
            break;
        }else if ( ret == TXDATABASE ){
            if( chkToken(sql,token,TXARG) )         {err("CREATE DATABASE NO TABLE ERROR"); return NULL;}//tablename
            if( catalog.dblist.count((char*)token) ){err("DATABASE ALREADY EXISTS");        return NULL;}//dbname
            //tokenŃf[^x[X쐬
            catalog.DBCreate(token);
            break;
        }else{
            err("What to do?");
            return NULL;
        }
        //break;
    case  TXINSERT://INSERT INTO TABLENAME(fieldname1,fieldname2,..) VALUES(value1,value2,...);
        if( chkToken(sql,token,TXINTO) )  {err("INSERT SYNTAX ERROR"); return NULL;}//INTO
        if( chkToken(sql,token,TXARG) )   {err("INSERT NO TABLE NAME");return NULL;}//TABLENAME
        tables.push_back((char*)token);
        if( chkToken(sql,token,TXPS) )    {err("INSERT SYNTAX ERROR"); return NULL;}//(
        for(;;){
            ret = getToken(sql,token);
            if( ret == TXARG ){
                colnams.push_back((char*)token);
            }else if ( ret == TXCM ){
                continue;
            }else if ( ret == TXPE ){
                break;
            }else{
                err("INSERT INVALID FIELD NAME");
                return NULL;//Field Name
            }
        }
        if( chkToken(sql,token,TXVALUES) ){err("INSERT SYNTAX ERROR"); return NULL;}//VALUES
        if( chkToken(sql,token,TXPS) )    {err("INSERT SYNTAX ERROR"); return NULL;}//(
        for(;;){
            ret = getToken(sql,token);
            if( ret == TXARG ){
                values.push_back((char*)token);
            }else if ( ret == TXCM ){
                continue;
            }else if ( ret == TXPE ){
                break;
            }else{
                err("INSERT INVALID FIELD NAME");
                return NULL;//Field Name
            }
        }
        //INSERTs
        //e[uI
        if( tbllist.count(tables[0]) == 0 ){
            err("TABLE NOT FOUND");
            return NULL;
        }
        if ( tbllist[tables[0]]->Insert(colnams,values) ){
            return NULL;
        }
        break;
    case  TXUPDATE://UPDATE TABLENAME SET field = value, field = value.. WHERE cond1,op1,cond2;
        //e[u擾
        if( chkToken(sql,token,TXARG) )             {err("UPDATE NO TABLE ERROR"); return NULL;}//table
        tables.push_back( (char*)token );

        if( chkToken(sql,token,TXSET) )             {err("UPDATE SYNTAX ERROR");   return NULL;}//SET
        //J擾
        for(;;){
            if( chkToken(sql,token,TXARG) )         {err("UPDATE NO ARG ERROR");   return NULL;}//ARG
            colnams.push_back( (char*)token );
            if( chkToken(sql,token,TXARG) )         {err("UPDATE SYNTAX ERROR");   return NULL;}//=
            if( strcmp(token,"=") != 0 )            {err("UPDATE SYNTAX ERROR");   return NULL;}//=
            if( chkToken(sql,token,TXARG) )         {err("UPDATE NO VALUE ERROR"); return NULL;}//ARG
            values.push_back( (char*)token );
            ret = getToken(sql,token);
            if( ret != TXCM )                       break;
        }
        //WHERE擾
        if( ret == TXWHERE ){
            cond.push_back("AND");               //1AND
            for(;;){
                if( chkToken(sql,token,TXARG) ) {err("UPDATE NO ARG IN WHERE"); return NULL;}//arg1
                cond.push_back((char*)token);
                if( chkToken(sql,token,TXARG) ) {err("UPDATE NO OPE IN WHERE"); return NULL;}//op1
                if( strstr("= >= <= > < ",(char*)token) == NULL )
                                                {err("UPDATE NO OPE IN WHERE"); return NULL;}//op1
                cond.push_back((char*)token);
                if( chkToken(sql,token,TXARG) ) {err("UPDATE NO ARG IN WHERE"); return NULL;}//arg2
                cond.push_back((char*)token);

                ret = getToken(sql,token);
                if( ret != TXAND && ret != TXOR){
                    break;
                }
                cond.push_back((char*)token);
            }
        }
        //̏
        while( ret != TXED && ret != TXNONE ){
            ret = getToken(sql,token);
        }
        
        //e[u擾
        tbl = tbllist[tables[0]];
        //wheres
        tbl->Update(colnams,values,cond,clmalias,tblalias);
        break;
    case  TXDELETE://DELETE FROM TABLENAME WHERE cond1,op1,cond2
        //e[u擾
        if( chkToken(sql,token,TXARG) )             {err("DELETE NO TABLE ERROR"); return NULL;}//table name
        tables.push_back( (char*)token );

        if( chkToken(sql,token,TXFROM) )            {err("DELETE SYNTAX ERROR");   return NULL;}//from
        ret = getToken(sql,token);
        //WHERE擾
        if( ret == TXWHERE ){
            cond.push_back("AND");              //1AND
            for(;;){
                if( chkToken(sql,token,TXARG) ) {err("DELETE NO ARG IN WHERE"); return NULL;}//arg1
                cond.push_back((char*)token);
                if( chkToken(sql,token,TXARG) ) {err("DELETE NO OPE IN WHERE"); return NULL;}//op1
                if( strstr("= >= <= > < ",(char*)token) == NULL )
                                                {err("DELETE NO OPE IN WHERE"); return NULL;}//op1
                cond.push_back((char*)token);
                if( chkToken(sql,token,TXARG) ) {err("DELETE NO ARG IN WHERE"); return NULL;}//arg2
                cond.push_back((char*)token);

                ret = getToken(sql,token);
                if( ret != TXAND && ret != TXOR){
                    break;
                }
                cond.push_back((char*)token);
            }
        }
        //̏
        while( ret != TXED && ret != TXNONE ){
            ret = getToken(sql,token);
        }
        
        //e[u擾
        tbl = tbllist[tables[0]];
        //wheres
        tbl->Delete(cond,clmalias,tblalias);
        break;
    //show databases
    //show tables
    //show tables form database
    case TXSHOW:
        ret = getToken(sql,token);
        if( ret == TXDATABASES ){
            catalog.ShowCatalog();
            break;
        }else if ( ret == TXTABLES ){
            ret = getToken(sql,token);
            if( ret == TXFROM ){
                if( chkToken(sql,token,TXARG) ){
                    err( "NO DATABASE SET");
                    return NULL;
                }
            }else if ( ret == TXED || ret == TXNONE ){
                map<string,Table*>::iterator it;
                for( it = tbllist.begin() ; it != tbllist.end() ; it++ ){
                    printf( "%s\n",it->first.c_str() );
                }
            }
            break;
        }
        break;
    case TXDROP:
        ret = getToken(sql,token);
        if( ret == TXTBL ){
            if( chkToken(sql,token,TXARG) )      {err("DROPTABLE NO TABLE ERROR"); return NULL;}//tablename
            //`FbNB̃e[u邩H
            if( ! tbllist.count((char*)token) ){
                err( "Table not exist");
                return NULL;
            }
            Table* tbl = tbllist[(char*)token];
            delete tbl;
            tbllist.erase((char*)token);
            break;
        }else if ( ret == TXDATABASE ){
            if( chkToken(sql,token,TXARG) )         {err("CREATE DATABASE NO TABLE ERROR"); return NULL;}//tablename
            //`FbNB̃f[^x[X邩H
            if( name == (char*)token ){
                err( "Using this Database");
                return NULL;
            }
            if( ! catalog.dblist.count((char*)token) ){
                err( "Database not exist");
                return NULL;
            }
            Database* db = catalog.dblist[(char*)token];
            delete db;
            catalog.dblist.erase((char*)token);
            break;
        }else{
            err("What to do?");
            return NULL;
        }
        //break;
    case TXHELP:
        printf( "show databases;\n"
                "show tables;\n"
                "create database DATABASE_NAME;\n"
                "create table TABLE_NAME(FIELD_NAME1 number/string,...);\n"
                "use DATABASE_NAME;\n"
                "drop DATABASE_NAME;\n"
                "drop TABLE_NAME;\n"
                "select/insert/update/delete..\n" );
        break;
    }
    return (Table*)-1;
}
////////////////////////////////////////////////////////////////////////////
int Database::LoadFromFile(string file){
    //tableSǂݍ
    int    ret;
    size_t max;
    int    fd;
    tbllist.clear();
    if( FileExists(file.c_str()) ){
        fd = open(file.c_str(), O_RDONLY | O_BINARY );
    //t@CȂꍇt@C쐬ďI
    }else{
        fd = open(file.c_str(), O_CREAT | O_TRUNC | O_WRONLY | O_BINARY , S_IREAD | S_IWRITE );
        close(fd);
        return -1;
    }
    //e[u擾
    if( read( fd, &max, sizeof( size_t )) != sizeof(size_t) ){close(fd); return -1;}
    //e[u擾
    for( size_t i = 0 ; i < max ; i++ ){
        Table* tbl = new Table();
        if( tbl->LoadFromFile(fd) < 0 ){
            err( "table load error\n");
            close(fd);
            return -1;
        }
        tbllist[tbl->name] = tbl;
    }
    close(fd);
    return 0;
}
////////////////////////////////////////////////////////////////////////////
int Database::SaveToFile(string file){
    int    ret;
    size_t max;
    size_t len;
    int fd = open(file.c_str(), O_CREAT | O_TRUNC | O_WRONLY | O_BINARY , S_IREAD | S_IWRITE );
    if( fd < 0 ){
        return -1;
    }
    //OcatalogNXŕۑ
    //e[uۑ
    max = tbllist.size();
    if( write( fd, &max, sizeof(size_t)) != sizeof(size_t) ) {close(fd); return -1;}
    //e[uۑ
    map<string,Table*>::iterator it;
    for( it = tbllist.begin() ; it != tbllist.end() ; it++ ){
        if( it->second->SaveToFile(fd) < 0 ){
            err( "table save error\n");
            close(fd);
            return -1;
        }
    }
    close( fd );
    return 0;
}


/////////////////////////////////////////////////////////////////////////////
//J^ONX
////////////////////////////////////////////////////////////////////////////
#define CATFILE "_cybeleDBcat"
//VOg擾
DBCatalog& DBCatalog::getInstance(void){
    static DBCatalog instance;
    return instance;
}
////////////////////////////////////////////////////////////////////////////
//f[^x[Xɐڑ
Database* DBCatalog::DBConnect(char* DBName){
    if( dblist.count(DBName) ){
        //o^
        if( dblist[DBName] == NULL ){
            dblist[DBName] = new Database(DBName);
        //o^ς
        }else{
            dblist[DBName]->ref++;
        }
        return dblist[DBName];
    }
    return NULL;
}
////////////////////////////////////////////////////////////////////////////
//VKDB쐬
Database* DBCatalog::DBCreate(char* DBName){
    if( dblist.count(DBName) ){
        err( "database already exists");
        return NULL;
    }
    dblist[DBName] = new Database(DBName);
    return dblist[DBName];
}
////////////////////////////////////////////////////////////////////////////
size_t DBCatalog::ShowCatalog(void)
{
    map<string,Database*>::iterator it;
    for( it = dblist.begin() ; it != dblist.end() ; it++ ){
        printf( "%s\n",(*it).first.c_str());
    }
    return dblist.size();
}
////////////////////////////////////////////////////////////////////////////
int DBCatalog::LoadFromFile(void)
{
    int    ret;
    size_t len;
    size_t max;
    int    fd; 
    char   name[1024];
    dblist.clear();
    //I[v
    if( FileExists(CATFILE) ){
        fd = open(CATFILE, O_RDONLY | O_BINARY );
    }else{
        //Ȃꍇ͐VKɍďI
        fd = open(CATFILE, O_CREAT | O_TRUNC | O_WRONLY | O_BINARY , S_IREAD | S_IWRITE );
        close(fd);
        return 0;
    }
    //dbname read
    if( read(fd, &max, sizeof(size_t)) != sizeof(size_t) )    {err("can't read");close(fd);return -1;}
    //read all database
    for(size_t i =0; i < max; i++){
        if( read(fd, &len, sizeof(size_t)) != sizeof(size_t) ){err("can't read len");close(fd);return -1;}
        if( read(fd, name, len )           != (int)len       ){err("can't read dbname");close(fd);return -1;}
        name[len] = 0;
        //[hDBNULLBCreateō쐬
        dblist[name] = NULL;
    }
    close( fd );
    return 0;
}
//create database
//use database󂯕t
////////////////////////////////////////////////////////////////////////////
int DBCatalog::SaveToFile(void)
{
    size_t max;
    size_t len;
    //DBCatalogۑ
    int fd = open(CATFILE, O_CREAT | O_TRUNC | O_WRONLY | O_BINARY , S_IREAD | S_IWRITE );
    if ( fd < 0 ){
        return -1;
    }
    //dbnameۑ
    map<string,Database*>::iterator it;
    max = dblist.size();
    if( write(fd, &max, sizeof(size_t))     != sizeof(size_t) ) {close(fd); return -1;}
    for( it = dblist.begin() ; it != dblist.end() ; it++ ){
        len = it->first.length();
        if( write(fd,&len,sizeof(size_t))   != sizeof(size_t) ) {close(fd); return -1;}
        if( write(fd,it->first.c_str(),len) != (int)len       ) {close(fd); return -1;}
    }
    // t@CN[Y
    close( fd );
    for( it = dblist.begin() ; it != dblist.end() ; it++ ){
        if( it->second != NULL ){
            delete it->second;
        }
    }
    return 0;
}
////////////////////////////////////////////////////////////////////////////
DBCatalog::DBCatalog(void){
    dblist.clear();
    if( LoadFromFile() < 0 ){
        err( "DataBase Read Error");
    }
}
////////////////////////////////////////////////////////////////////////////
DBCatalog::~DBCatalog(void){
    int ret;
    int max;
    refs--;
    SaveToFile();
}

////////////////////////////////////////////////////////////////////////////
int main(int argc, char* argv[])
{
    unsigned char cmd[2014];
    unsigned char cmd2[2014];
    unsigned char token[2014];
    unsigned char* p; 
    unsigned char* q;
    int ret;
    //KvȂDBCreateDB쐬
    //ʏDBConnectDBɐڑ
    //I܂͓KXtextɏŏI
    debug_log_initialize("debug.log");
    Database* db;
    if( catalog.dblist.size() == 0){
         db = catalog.DBCreate("_SYSTEM");
    }else{
         db = catalog.DBConnect("_SYSTEM");
    }
    //FILE* rs = fopen( "sample_sql.txt","rt");
    for(;;){
        gets((char*)cmd);
        //fgets(cmd,1024,rs);
        //while( cmd[strlen(cmd)-1]< ' ' ){
        //    cmd[strlen(cmd)-1] = 0;
        //}
        //puts( cmd );
        strcpy( (char*)cmd2, (char*)cmd);
        ret = getToken(cmd,token);
        if     ( ret == TXQUIT ) break;
        else if( ret == TXUSE ){
            if( chkToken(cmd,token,TXARG) ) {
                err("SYNTAX ERROR");
                continue;
            }
            Database *db1 = catalog.DBConnect(token);
            if( db1 ){
                db = db1;
                printf( "OK\n");
            }else{
                printf( "ERROR\n" );
            }
        }else{
            Table* tbl = db->SQL(cmd2);
            if( (int)tbl == -1 ){
                printf( "OK\n" );
            }else if(tbl == NULL ){
                printf( "ERROR\n" );
            }else{
                printf( "%s\n", tbl->toString());
                delete tbl;
            }
            continue;
        }
        
    }
    //fclose( rs );
    system("pause");
    return 0;
}
//---------------------------------------------------------------------------
 

