#ifndef nodehpp
#define nodehpp
#include <string>
#include <vector>
#include <iostream>
/////////////////////////////////////////////////////////////////////////////
typedef enum {STRING,NUMBER} dataType;
typedef enum {ASC,DESC} orderType;
/////////////////////////////////////////////////////////////////////////////
using namespace std;
class Node{
private:
    //eւ̐擪|C^
    vector<string>  data;
    //f[^E^Cv
    dataType        type;
    //RXgN^
public:
    Node(dataType mytype)
    {
        type = mytype;
        data.clear();
    }
    Node(const Node* nd){
        data.clear();
        type = nd->type;
        for( size_t i = 0 ; i < nd->data.size() ; i++ ){
            data.push_back(nd->data[i]);
        }
    }
    ~Node(void){
        data.clear();
    }
    //m[h̕擾
    int Delete(size_t ptr)
    {
        if( ptr > data.size() ){
            return -1;
        }else{
            data.erase(data.begin()+ptr);//1s폜
            return 0;
        }
    }
    //m[h̕擾
    char* get(vector<int>&index, size_t ptr, char* temp)
    {
        if( index.size() > 0 ){
            return getNode(index[ptr],temp);
        }else{
            return getNode(ptr,temp);
        }
    }
    //wm[h̕擾
    char* getNode(size_t ptr, char* temp)
    {
        if( type == STRING ){
            strcpy( temp,data[ptr].c_str());
        }else{
            sprintf( temp, "%d", atoi((char*)data[ptr].c_str()));
        }
        return temp;
    }
    //ݒ肵
    size_t size()
    {
        return data.size();
    }
    //\[gʂvector<int>ɕۑ
    void sort(vector<int> &index, orderType mytype){
        index.clear();
        size_t siz = size();
        for( size_t i = 0 ; i < siz ; i++ ){
            index.push_back(i);
        }
        //l
        if( type == NUMBER){
            if( mytype == ASC ){
                //
                for( size_t i = 0 ; i < siz-1 ; i++ ){
                    for( size_t j = i+1 ; j < siz ; j++ ){
                        int ii = index[i];
                        int jj = index[j];
                        if( data[ii][0] == '-' || data[jj][0] == '-' ){
                            if( data[ii] < data[jj] ){
                                swap(index[i],index[j]);
                            }
                        }else{
                            if( data[ii] > data[jj] ){
                                swap(index[i],index[j]);
                            }
                        }
                    }
                }
            }else{
                //~
                for( size_t i = 0 ; i < siz-1 ; i++ ){
                    for( size_t j = i+1 ; j < siz ; j++ ){
                        int ii = index[i];
                        int jj = index[j];
                        if( data[ii][0] == '-' || data[jj][0] == '-' ){
                            if( data[ii] > data[jj] ){
                                swap(index[i],index[j]);
                            }
                        }else{
                            if( data[ii] < data[jj] ){
                                swap(index[i],index[j]);
                            }
                        }
                    }
                }
            }
        }else{
            if( mytype == ASC ){
                //
                for( size_t i = 0 ; i < siz-1 ; i++ ){
                    for( size_t j = i+1 ; j < siz ; j++ ){
                        if( data[index[i]] > data[index[j]] ){
                            swap(index[i],index[j]);
                        }
                    }
                }
            }else{
                //~
                for( size_t i = 0 ; i < siz-1 ; i++ ){
                    for( size_t j = i+1 ; j < siz ; j++ ){
                        if( data[index[i]] < data[index[j]] ){
                            swap(index[i],index[j]);
                        }
                    }
                }
            }
        }
    } 
    //i[Ă邩H
    int contains(char* letters)
    {
        for( size_t i = 0 ; i < data.size();i++){
            if( data[i] == letters ){
                return i;
            }
        }
        return -1;
    }
    //o^
    void put(const string& letters,int ptr=-1)
    {
        //string tmp = letters;
        if( type == NUMBER ){
            char work[128];
            sprintf( work, "%+010d",atoi(letters.c_str()));
            if( ptr >= 0 ){
                data[ptr] = work;
            }else{
                data.push_back(work);
            }
        }else{
            if( ptr >= 0 ){
                data[ptr]  = letters;
            }else{
                data.push_back(letters);
            }
        }
        return;
    }
    //A
    int LoadFromFile(int fd)
    {
        int            ret;
        unsigned short len;
        size_t         max;
        data.clear();//KvH
        char work[1024];
        //f[^E^Cv擾
        if( read(fd,&type,sizeof(dataType))   != sizeof(dataType)) return -1;
        //擾
        if( read(fd,&max,sizeof(size_t))      != sizeof(size_t) )  return -1;
        //f[^擾
        for( size_t i = 0 ; i < max ; i++ ){
            if( read(fd,&len,sizeof(unsigned short))  != sizeof(unsigned short) )  return -1;
            if( read(fd,work,len)                     != (int)len               )  return -1;
            work[len] = 0;
            data.push_back(work);
        }
        return 0;
    }
    //ۑ
    int SaveToFile(int fd)
    {
        int            ret;
        unsigned short len;
        size_t         max;
        max = data.size();
        //f[^E^Cvۑ
        if( write(fd,&type,sizeof(dataType))   != sizeof(dataType)) return -1;
        //ۑ
        if( write(fd,&max,sizeof(size_t))      != sizeof(size_t) )  return -1;
        //f[^ۑ
        for( size_t i = 0 ; i < max ; i++ ){
            len = data[i].size();
            if( write(fd, &len,sizeof(unsigned short)) != sizeof(unsigned short) )  return -1;
            if( write(fd,data[i].c_str(),len)          != (int)len               )  return -1;
        }
        return 0;
    }
};
 




#endif
